<?php



			/*
			Plugin Name:    MetroShrink -  Ә 
			Plugin URI: http://persianScript.ir
			Description: Connect your MetroShrink service with Wordpress
			Version: 1.0
			Author: PersianScript.ir
			Author URI: http://persianScript.ir
			*/


			class MetroShrink_Linker_Lite
			{
			     // variables
			     private $base_path;
			     private $base_url;

			     // constructor
			     public function __construct()
			     {
			          $this->base_path = dirname( __file__ ) . DIRECTORY_SEPARATOR;
			          $this->base_url = plugin_dir_url( __file__ );
                                                                
			          // backend
			          if ( is_admin() ) {
			               register_activation_hook( __file__, array( $this, 'activate' ) );
			               add_action( 'admin_menu', array( $this, 'admin_menu' ) );
			               // frontend
			          } else {
			               add_filter( 'the_content', array( $this, 'make_links' ) );
                           add_shortcode( 'metroshrink', array( $this, 'metroShrink_url' ) );
			          }
			     }

			     // make links
			     public function make_links( $content )
			     {
			          if ( in_the_loop() ) {
			               $regex = '@((?<!src=")(https?://)([-\w]+\.[-\w\.]+)+\w(:\d+)?(/([-\w/_\.\,]*(\?\S+)?)?)*)@';
			               return preg_replace_callback( $regex, array( $this, 'replaceUrls' ), $content );
			          }
			     }

			     // replace urls
			     public function replaceUrls( $data )
			     {
			          $url = get_transient( 'ms_' . md5( get_option( 'metroshrink_domain' ) . $data[0] ) );
			          if ( !$url ) {
			               $url = $this->connectAPI( $data[0] );
			               set_transient( 'ms_' . md5( get_option( 'metroshrink_domain' ) . $data[0] ), $url, 60 * 60 * 24 * 30 * 12 );
			          }
			          return $url;
			     }

                 // verify metroshrink installation   
			     private function verifyDomain( $domain )
			     {
			          $data = wp_remote_fopen( $domain . '/inc/check.php' );
			          $data = json_decode( $data, true );
			          return isset( $data['success'] ) ? true : false;
			     }

			     // connect API
			     public function connectAPI( $url )
			     {
                      $domain = get_option( 'metroshrink_domain' );
			          $data = wp_remote_fopen( $domain . '/API/write/get?url=' . urlencode( $url ) . '&via=wp_' . $_SERVER['SERVER_NAME'] );
			          $data = json_decode( $data, true );
			          return isset( $data['success'] ) && $data['success'] === true ? $data['data']['url'] : $url;
			     }
                 
                 // validate urls
			     private function validateUrl( $url )
			     {
			         $url = strtolower( $url );
                     $regex = "/^".
                              "(?:https?:\\/\\/)".  // Look for http://, but make it optional.
                              "(?:[a-zA-Z0-9\p{Cyrillic}][a-zA-Z0-9\p{Cyrillic}_-]*(?:\\.[a-zA-Z0-9\p{Cyrillic}][a-zA-Z0-9\p{Cyrillic}_-]*))". // Server name
                              "(?:\\d+)?".         // Optional port number
                              "(?:\\/\\.*)?/iu";    // Optional training forward slash and page info                      
			          return preg_match( $regex, $url ) ? true : false;
			     }

			     // activate
			     public function activate()
			     {
			          if ( !get_option( 'metroshrink_domain' ) )
                      add_option( 'metroshrink_domain', 'http://mtro.us', '', 'yes' );
			     }

			     // admin menu
			     function admin_menu()
			     {
			          $page = add_menu_page( 'MetroShrink', 'MetroShrink', 'manage_options', 'MetroShrink', array( $this, 'admin_page' ), plugin_dir_url( __file__ ) .
			               'img/icon.png' );
			     }
                 
                 // admin page   
			     public function admin_page()
			     {
			          if ( !is_admin() || !current_user_can( 'manage_options' ) )
			               die( 'Not allowed' );
                           
			          $domain = isset( $_POST['metroshrink_domain'] ) && $this->validateUrl( $_POST['metroshrink_domain'] ) ? stripslashes( $_POST['metroshrink_domain'] ) : false;
			          if ( $domain ) {
                         if ( $this->verifyDomain( $domain ) ){
                            update_option( 'metroshrink_domain', $domain ); 
                         } else {
                            $msg = 'Invalid Domain!';
                         }   			               
			          } 
?>
                        <div class="wrap">  
                            <div id="icon-options-general" class="icon32"></div>
                            <h2>Metro Shrink - Linker Lite</h2>
                            <br class="clear" /> 
<?php 
                        if ( isset( $msg ) ){
                            echo '<div id="message" class="updated below-h2"><p>'.$msg.'</p></div>';
                        }
?>                              
                            <form method="post" action="<?php echo admin_url( "admin.php?page=MetroShrink" ); ?>">  
                                <p><strong>Metro Shrink Base Url:</strong><br />  
                                    <input type="text" name="metroshrink_domain" size="45" value="<?php echo get_option('metroshrink_domain'); ?>" />  
                                </p>  
                                <p>
                                    <input type="submit" name="Submit" value="Save" class="button-primary button80"/>
                                </p>  
                            </form>  
                        </div>  
<?php
			     }
                 
			     // self url shortcode
			     public function metroShrink_url( $atts )
			     {
			          extract( shortcode_atts( array(
			               "url" => get_permalink(),
                           ), $atts ) );
                    $url = $this->validateUrl($url) ? $url : false;                           
                    return $url ? $this->connectAPI( $url ) : '';
			     }                 

			     // get current url
			     public function getCurrentUrl()
			     {
			          $url = 'http';
			          $url .= isset( $_SERVER["HTTPS"] ) && $_SERVER["HTTPS"] == 'on' ? 's' : '';
			          $url .= "://";
			          $url .= $_SERVER["SERVER_PORT"] != '80' ? $_SERVER['SERVER_NAME'] . ':' . $_SERVER['SERVER_PORT'] . $_SERVER['REQUEST_URI'] : $_SERVER['SERVER_NAME'] .
			               $_SERVER['REQUEST_URI'];
			          return $url;
			     }
                 
			}

			// run baby!
			new MetroShrink_Linker_Lite();
